---
title: llarp::PrintHelper
summary: helper struct 

---

# llarp::PrintHelper



helper struct 


`#include <printer.hpp>`

## Public Functions

|                | Name           |
| -------------- | -------------- |
| template <typename Type \> <br>void | **[print](Classes/structllarp_1_1PrintHelper.md#function-print)**(std::ostream & stream, const Type & value, int level, int spaces) |
| template <typename InputIt \> <br>void | **[print](Classes/structllarp_1_1PrintHelper.md#function-print)**(std::ostream & stream, const InputIt & begin, const InputIt & end, int level, int spaces) |
| void | **[printType](Classes/structllarp_1_1PrintHelper.md#function-printtype)**(std::ostream & stream, char value, int level, int spaces, [traits::select::Case](Classes/classllarp_1_1traits_1_1select_1_1Case.md)< std::is_fundamental > ) |
| void | **[printType](Classes/structllarp_1_1PrintHelper.md#function-printtype)**(std::ostream & stream, bool value, int level, int spaces, [traits::select::Case](Classes/classllarp_1_1traits_1_1select_1_1Case.md)< std::is_fundamental > ) |
| template <typename Type \> <br>void | **[printType](Classes/structllarp_1_1PrintHelper.md#function-printtype)**(std::ostream & stream, Type value, int level, int spaces, [traits::select::Case](Classes/classllarp_1_1traits_1_1select_1_1Case.md)< std::is_fundamental > ) |
| template <typename Type \> <br>void | **[printType](Classes/structllarp_1_1PrintHelper.md#function-printtype)**(std::ostream & stream, Type value, int level, int spaces, [traits::select::Case](Classes/classllarp_1_1traits_1_1select_1_1Case.md)< std::is_enum > ) |
| template <typename Type \> <br>void | **[printType](Classes/structllarp_1_1PrintHelper.md#function-printtype)**(std::ostream & stream, Type value, int level, int spaces, [traits::select::Case](Classes/classllarp_1_1traits_1_1select_1_1Case.md)< std::is_function > ) |
| void | **[printType](Classes/structllarp_1_1PrintHelper.md#function-printtype)**(std::ostream & stream, const char * value, int level, int spaces, [traits::select::Case](Classes/classllarp_1_1traits_1_1select_1_1Case.md)< std::is_pointer > ) |
| void | **[printType](Classes/structllarp_1_1PrintHelper.md#function-printtype)**(std::ostream & stream, const void * value, int level, int spaces, [traits::select::Case](Classes/classllarp_1_1traits_1_1select_1_1Case.md)< std::is_pointer > ) |
| template <typename Type \> <br>void | **[printType](Classes/structllarp_1_1PrintHelper.md#function-printtype)**(std::ostream & stream, const Type * value, int level, int spaces, [traits::select::Case](Classes/classllarp_1_1traits_1_1select_1_1Case.md)< std::is_pointer > ) |
| template <typename Type \> <br>void | **[printType](Classes/structllarp_1_1PrintHelper.md#function-printtype)**(std::ostream & stream, const Type * value, int level, int spaces, [traits::select::Case](Classes/classllarp_1_1traits_1_1select_1_1Case.md)< std::is_array > ) |
| void | **[printType](Classes/structllarp_1_1PrintHelper.md#function-printtype)**(std::ostream & stream, const std::string & value, int level, int spaces, [traits::select::Case](Classes/classllarp_1_1traits_1_1select_1_1Case.md)< [traits::is_container](Classes/structllarp_1_1traits_1_1is__container.md) > ) |
| void | **[printType](Classes/structllarp_1_1PrintHelper.md#function-printtype)**(std::ostream & stream, const std::string_view & value, int level, int spaces, [traits::select::Case](Classes/classllarp_1_1traits_1_1select_1_1Case.md)< [traits::is_container](Classes/structllarp_1_1traits_1_1is__container.md) > ) |
| template <typename Type \> <br>void | **[printType](Classes/structllarp_1_1PrintHelper.md#function-printtype)**(std::ostream & stream, const Type & value, int level, int spaces, [traits::select::Case](Classes/classllarp_1_1traits_1_1select_1_1Case.md)< [traits::is_container](Classes/structllarp_1_1traits_1_1is__container.md) > ) |
| template <typename Type1 ,typename Type2 \> <br>void | **[printType](Classes/structllarp_1_1PrintHelper.md#function-printtype)**(std::ostream & stream, const std::pair< Type1, Type2 > & value, int level, int spaces, [traits::select::Case](Classes/classllarp_1_1traits_1_1select_1_1Case.md)<> ) |
| template <typename... Types\> <br>void | **[printType](Classes/structllarp_1_1PrintHelper.md#function-printtype)**(std::ostream & stream, const std::tuple< Types... > & value, int level, int spaces, [traits::select::Case](Classes/classllarp_1_1traits_1_1select_1_1Case.md)<> ) |
| template <typename Type \> <br>void | **[printType](Classes/structllarp_1_1PrintHelper.md#function-printtype)**(std::ostream & stream, const Type & value, int level, int spaces, [traits::select::Case](Classes/classllarp_1_1traits_1_1select_1_1Case.md)<> ) |

## Public Functions Documentation

### function print

```cpp
template <typename Type >
static inline void print(
    std::ostream & stream,
    const Type & value,
    int level,
    int spaces
)
```


### function print

```cpp
template <typename InputIt >
static inline void print(
    std::ostream & stream,
    const InputIt & begin,
    const InputIt & end,
    int level,
    int spaces
)
```


### function printType

```cpp
static void printType(
    std::ostream & stream,
    char value,
    int level,
    int spaces,
    traits::select::Case< std::is_fundamental > 
)
```


### function printType

```cpp
static void printType(
    std::ostream & stream,
    bool value,
    int level,
    int spaces,
    traits::select::Case< std::is_fundamental > 
)
```


### function printType

```cpp
template <typename Type >
static inline void printType(
    std::ostream & stream,
    Type value,
    int level,
    int spaces,
    traits::select::Case< std::is_fundamental > 
)
```


### function printType

```cpp
template <typename Type >
static inline void printType(
    std::ostream & stream,
    Type value,
    int level,
    int spaces,
    traits::select::Case< std::is_enum > 
)
```


### function printType

```cpp
template <typename Type >
static inline void printType(
    std::ostream & stream,
    Type value,
    int level,
    int spaces,
    traits::select::Case< std::is_function > 
)
```


### function printType

```cpp
static void printType(
    std::ostream & stream,
    const char * value,
    int level,
    int spaces,
    traits::select::Case< std::is_pointer > 
)
```


### function printType

```cpp
static void printType(
    std::ostream & stream,
    const void * value,
    int level,
    int spaces,
    traits::select::Case< std::is_pointer > 
)
```


### function printType

```cpp
template <typename Type >
static inline void printType(
    std::ostream & stream,
    const Type * value,
    int level,
    int spaces,
    traits::select::Case< std::is_pointer > 
)
```


### function printType

```cpp
template <typename Type >
static inline void printType(
    std::ostream & stream,
    const Type * value,
    int level,
    int spaces,
    traits::select::Case< std::is_array > 
)
```


### function printType

```cpp
static inline void printType(
    std::ostream & stream,
    const std::string & value,
    int level,
    int spaces,
    traits::select::Case< traits::is_container > 
)
```


### function printType

```cpp
static void printType(
    std::ostream & stream,
    const std::string_view & value,
    int level,
    int spaces,
    traits::select::Case< traits::is_container > 
)
```


### function printType

```cpp
template <typename Type >
static inline void printType(
    std::ostream & stream,
    const Type & value,
    int level,
    int spaces,
    traits::select::Case< traits::is_container > 
)
```


### function printType

```cpp
template <typename Type1 ,
typename Type2 >
static inline void printType(
    std::ostream & stream,
    const std::pair< Type1, Type2 > & value,
    int level,
    int spaces,
    traits::select::Case<> 
)
```


### function printType

```cpp
template <typename... Types>
static inline void printType(
    std::ostream & stream,
    const std::tuple< Types... > & value,
    int level,
    int spaces,
    traits::select::Case<> 
)
```


### function printType

```cpp
template <typename Type >
static inline void printType(
    std::ostream & stream,
    const Type & value,
    int level,
    int spaces,
    traits::select::Case<> 
)
```


-------------------------------

Updated on 2022-07-24 at 00:14:34 +0000