---
title: llarp/util/logging/android_logger.hpp

---

# llarp/util/logging/android_logger.hpp



## Namespaces

| Name           |
| -------------- |
| **[llarp](Namespaces/namespacellarp.md)** <br>[crypto.hpp] |

## Classes

|                | Name           |
| -------------- | -------------- |
| struct | **[llarp::AndroidLogStream](Classes/structllarp_1_1AndroidLogStream.md)**  |




## Source code

```cpp
#pragma once

#include "logstream.hpp"

#include <iostream>

namespace llarp
{
  struct AndroidLogStream : public ILogStream
  {
    void
    PreLog(
        std::stringstream& s,
        LogLevel lvl,
        std::string_view filename,
        int lineno,
        const std::string& nodename) const override;

    void
    Print(LogLevel lvl, std::string_view filename, const std::string& msg) override;

    void
    PostLog(std::stringstream&) const override;

    void Tick(llarp_time_t) override;

    void
    ImmediateFlush() override{};
  };
}  // namespace llarp
```


-------------------------------

Updated on 2022-07-24 at 00:14:36 +0000
