---
title: llarp/hook/ihook.hpp

---

# llarp/hook/ihook.hpp



## Namespaces

| Name           |
| -------------- |
| **[llarp](Namespaces/namespacellarp.md)** <br>[crypto.hpp] |
| **[llarp::hooks](Namespaces/namespacellarp_1_1hooks.md)**  |

## Classes

|                | Name           |
| -------------- | -------------- |
| struct | **[llarp::hooks::IBackend](Classes/structllarp_1_1hooks_1_1IBackend.md)** <br>base type for event hook handlers  |




## Source code

```cpp
#pragma once
#include <string>
#include <unordered_map>
#include <memory>

namespace llarp
{
  namespace hooks
  {
    struct IBackend
    {
      virtual ~IBackend() = 0;
      virtual void
      NotifyAsync(std::unordered_map<std::string, std::string> params) = 0;

      virtual bool
      Start() = 0;

      virtual bool
      Stop() = 0;
    };

    using Backend_ptr = std::shared_ptr<IBackend>;

    inline IBackend::~IBackend() = default;
  }  // namespace hooks
}  // namespace llarp
```


-------------------------------

Updated on 2022-07-24 at 00:14:36 +0000
